part of flutter_kingmed_ui;

class LoadingDialog   {
  final BuildContext _context;
  bool isClose=true;
  bool barrierDismissible;
  double ?loadWidth;
  bool showBg;

  LoadingDialog(this._context,{this.barrierDismissible=true,this.loadWidth,this.showBg=false});

  ///打开loading
  void show({Function? onClosed}) {
    isClose=false;

    showDialog(
      context: _context,
      barrierDismissible: barrierDismissible,
      barrierColor: showBg?Colors.black54:Color(0x00000001),
      builder: (context) {
        return DialogView(loadWidth: loadWidth,);
      },
    ).then((value) {
        isClose=true;
    });

  }

  ///关闭loading
  void close() {
    if(isClose){
      return;
    }
    Navigator.of(_context).pop();
  }

}

class DialogView extends StatefulWidget{

  double ?loadWidth;

  DialogView({this.loadWidth});

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return _DialogViewState();
  }

}

class _DialogViewState extends State<DialogView> with TickerProviderStateMixin{
  Artboard ?_riveArtboard;
  double width=0;
  double uiWidth=375;
  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    rootBundle.load("packages/flutter_kingmed_ui/assets/klo.riv").then((value) async {
      final file = RiveFile.import(value);
      final artboard = file.mainArtboard;
      artboard.addController(SimpleAnimation('load'));
      setState(() => _riveArtboard = artboard);
    });
  }

  // 375 812
  double setWidth(double value){
    return width*value/uiWidth;
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    width=MediaQuery.of(context).size.width;
    print('load');
    return new Center( //保证控件居中效果
        child:Container(
           width: widget.loadWidth??setWidth(50),
           height:widget.loadWidth??setWidth(50),
           child: _riveArtboard==null?SizedBox():Rive(artboard:_riveArtboard!, alignment:Alignment.center, fit:BoxFit.contain, ),
        )
    );
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();

  }

}