part of flutter_kingmed_ui;

class LoadingDialogText {
  final BuildContext _context;
  bool isClose=true;
  bool barrierDismissible;
  String ? title; //标题
  TextStyle? titleStyle; //文字样式
  double? loadWidth; //加载动画的宽度

  LoadingDialogText(this._context,{this.barrierDismissible=true,this.titleStyle,this.title,this.loadWidth});

  ///打开loading
  void show({Function? onClosed}) {
    isClose=false;
    showDialog(
      context: _context,
      barrierDismissible: barrierDismissible,
      // barrierColor: Color(0x00000001),
      builder: (context) {
        return DialogViewText(title: title,titleStyle: titleStyle,loadWidth: loadWidth,);
      },
    ).then((value) {
        isClose=true;
    });
  }

  ///关闭loading
  void close() {
    if(isClose){
      return;
    }
    Navigator.of(_context).pop();
  }

}

class DialogViewText extends StatefulWidget{
  String? title;
  TextStyle? titleStyle;
  double? loadWidth;
  DialogViewText({this.title,this.titleStyle,this.loadWidth});

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return _DialogViewTextState();
  }

}

class _DialogViewTextState extends State<DialogViewText> with TickerProviderStateMixin{
  Artboard ?_riveArtboard;
  double width=0;
  double uiWidth=375;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    rootBundle.load("packages/flutter_kingmed_ui/assets/klo.riv").then((value) async {
      final file = RiveFile.import(value);
      final artboard = file.mainArtboard;
      artboard.addController(SimpleAnimation('load'));
      setState(() => _riveArtboard = artboard);
    });
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();

  }

  // 375 812
  double setWidth(double value){
    return width*value/uiWidth;
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    width=MediaQuery.of(context).size.width;

    return new Center(
        child:Container(
          // width: ScreenUtil().setWidth(50),
          // height: ScreenUtil().setWidth(50),
           padding: new EdgeInsets.fromLTRB(24, 16, 24,16),
           decoration: new BoxDecoration(
             color: Colors.white,
             borderRadius: BorderRadius.all(Radius.circular(6))
           ),
           child: Row(
             mainAxisAlignment: MainAxisAlignment.center,
             mainAxisSize: MainAxisSize.min,
             children: [

               Container(
                 width: widget.loadWidth??setWidth(40),
                 height:widget.loadWidth??setWidth(40),
                 child: _riveArtboard==null?SizedBox():Rive(artboard:_riveArtboard!, alignment:Alignment.center, fit:BoxFit.contain, ),
               ),

               SizedBox(
                 width: 12,
               ),

               Text(
                 widget.title??'加载中...',
                 style: widget.titleStyle??new TextStyle(
                      decoration: TextDecoration.none,
                      fontSize: 16,
                      color: Colors.black87
                 ),
               ),

               SizedBox(
                //  width: ScreenUtil().setWidth(26),
               ),

             ],
           ),
        )
    );
  }

}