part of flutter_kingmed_ui;

class NormalHintDialog {
  final BuildContext _context;
  bool isClose=true;
  bool barrierDismissible;
  String content;
  String buttonText;
  String? actionkey; //为空值的时候每次提示，不为空时候只提示一次
  TextStyle? contentTextStyle;
  TextStyle? confirmTextStyle;
  Color ? backgroundColor;
  NormalHintDialog(this._context,
      {this.barrierDismissible=true,
        this.actionkey,
        required this.content,
        this.buttonText='我知道了',
        this.contentTextStyle,
        this.confirmTextStyle,
        this.backgroundColor
      });

  ///打开loading
  void show({Function? onClosed}) async {
    isClose=false;
    if(actionkey==null){
       showIconDialog();
    }else{
      SharedPreferences prefs = await SharedPreferences.getInstance();
      if(prefs.getString(actionkey!)==null){
         prefs.setString(actionkey!, 'value');
         showIconDialog();
      }
    }
  }

  void showIconDialog(){
    showDialog(
      context: _context,
      barrierDismissible: barrierDismissible,
      builder: (context) {
        return NormalHintDialogWidget(content: content,backgroundColor:backgroundColor,buttonText: buttonText,execute:(){
          Navigator.of(context).pop();
        });
      },
    ).then((value) {
      isClose=true;
    });
  }

  ///关闭loading
  void close() {
    if(isClose){
      return;
    }
    Navigator.of(_context).pop();
  }

}

class NormalHintDialogWidget extends StatefulWidget{
  String content;
  String buttonText;
  TextStyle? contentTextStyle;
  TextStyle? confirmTextStyle;
  VoidCallback execute;
  Color ? backgroundColor;
  NormalHintDialogWidget({required this.content, this.buttonText='确定',required this.execute,this.contentTextStyle,this.confirmTextStyle,this.backgroundColor});

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return NormalHintDialogWidgetState();
  }

}

class NormalHintDialogWidgetState extends State<NormalHintDialogWidget> with TickerProviderStateMixin{

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();

  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return new Center( //保证控件居中效果
        child:Container(
            //width: 320.w,
            //height: 400.h,
            margin:EdgeInsets.fromLTRB(60, 0, 60, 0),
            padding: EdgeInsets.fromLTRB(20, 20, 20, 0),
            decoration: new BoxDecoration(
              color: widget.backgroundColor??Colors.blueAccent,
              borderRadius: const BorderRadius.all(Radius.circular(15)),
            ),
            child:Column(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              crossAxisAlignment: CrossAxisAlignment.start,
              mainAxisSize: MainAxisSize.min,
              children: [

                Text('支持使用',style: widget.contentTextStyle ??
                    new TextStyle(
                        fontSize: 22,
                        decoration: TextDecoration.none,
                        color: Colors.white)
                ),

                Text('红外扫描',style: widget.contentTextStyle ??
                    new TextStyle(
                        fontSize: 22,
                        decoration: TextDecoration.none,
                        color: Colors.white)
                ),

                SizedBox(
                  height: 20,
                ),

                Text(widget.content,style: widget.contentTextStyle ??
                    new TextStyle(
                        fontSize: 14,
                        decoration: TextDecoration.none,
                        color: Colors.white)
                ),

                SizedBox(
                  height: 22,
                ),

                Row(
                  mainAxisAlignment: MainAxisAlignment.end,
                  children: [

                    TextButton(onPressed: (){

                        Navigator.of(context).pop();

                    }, child: Text('我知道了',style: widget.contentTextStyle ??
                        new TextStyle(
                            fontSize: 16,
                            decoration: TextDecoration.none,
                            fontWeight: FontWeight.bold,
                            color: Colors.white)
                    )),
                  ],
                )

              ],
            ),
        ),

    );

  }

}