part of flutter_kingmed_ui;

class StepLog extends StatefulWidget{
  String? mmdd;
  String ? hhss;
  String? description;
  String? operationName;
  bool isActive;
  bool isFirstItem;
  bool isLastItem;
  bool showNewest;
  double titleTextSize;
  Color? normalColor;
  Color? activeColor;
  Color? lineColor;
  Color? dateColor;
  Color? operationColor;

  StepLog({
    this.mmdd='12-12',
    this.hhss='11:00',
    this.operationName,
    this.isActive=false,
    this.isFirstItem=false,
    this.isLastItem=false,
    this.showNewest=false,
    this.description,
    this.titleTextSize=14,
    this.activeColor=Colors.blue,
    this.normalColor=Colors.grey,
    this.lineColor=Colors.grey,
    this.dateColor=Colors.grey,
    this.operationColor=Colors.grey,
  });

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return StepLogState();
  }

}

class StepLogState extends State<StepLog>{

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return IntrinsicHeight(
      child: Container(
        padding: new EdgeInsets.fromLTRB(24, 0,0,0),
        decoration: new BoxDecoration(
          color: new Color(0xffFCFBFC),
        ),
        child:Row(
          children: [

            Container(
              width: 44,
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [

                  SizedBox(
                    height: widget.titleTextSize,
                  ),

                  Text(
                    widget.mmdd!,
                    style: new TextStyle(
                        fontSize: widget.titleTextSize*0.8,
                        color: widget.isActive?widget.activeColor:widget.dateColor),
                  ),

                  SizedBox(
                    height: widget.titleTextSize/2,
                  ),

                  Text(
                    widget.hhss!,
                    style: new TextStyle(
                        fontSize: widget.titleTextSize,
                        color: widget.isActive?widget.activeColor:widget.dateColor),
                  ),

                ],
              ),
            ),

            SizedBox(
              width: 12,
            ),

            Column(
              children: [

                //线
                !widget.isFirstItem?Container(
                  width: 1,
                  height: widget.titleTextSize,
                  color: widget.lineColor,
                ):SizedBox(
                  height: widget.titleTextSize,
                ),

                //圆
                Container(
                  width: 12,
                  height: 12,
                  decoration: BoxDecoration(
                      color: widget.isActive?widget.activeColor:widget.lineColor,
                      shape: BoxShape.circle
                  ),
                ),

                //线
                !widget.isLastItem? Expanded(child:  Container(
                  width: 1,
                  height: double.infinity,
                  color: widget.lineColor,
                )):SizedBox(
                  height: widget.titleTextSize/2,
                ),

              ],
            ),

            SizedBox(
              width: 12,
            ),

            Expanded(child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [

                SizedBox(
                  height: widget.titleTextSize*2/3,
                ),

                widget.description!=null? Expanded(child: SelectableText(
                  widget.description.toString(),
                  style: new TextStyle(
                      fontSize: widget.titleTextSize,
                      color: widget.isActive?widget.activeColor:widget.normalColor),
                )):SizedBox(),

                SizedBox(
                  height: 8,
                ),

                Row(
                  children: [

                    widget.showNewest? Container(
                      padding: EdgeInsets.fromLTRB(4, 0, 4, 0),
                      margin: EdgeInsets.fromLTRB(0, 0, 8, 0),
                      decoration: BoxDecoration(
                          color: widget.activeColor,
                          borderRadius: BorderRadius.circular(4)
                      ),
                      child: Text('最新',
                        style: new TextStyle(
                            color: Colors.white,
                            fontSize: widget.titleTextSize*0.7
                        ),
                      ),
                    ):SizedBox(),

                    Expanded(
                      child: Text(
                      '操作人:'+(widget.operationName==null?'暂无':widget.operationName.toString()),
                      overflow: TextOverflow.ellipsis,
                      maxLines: 1,
                      style: new TextStyle(
                          fontSize: widget.titleTextSize,
                          color: widget.isActive?widget.activeColor:widget.operationColor),
                    ),)

                  ],
                ),

                SizedBox(
                  height: 12,
                ),

              ],
            )),

            SizedBox(
              width: 12,
            ),

          ],
        ) ,
      ),
    );

  }

}