part of flutter_kingmed_ui;

//提供不再提示选择弹窗
//
//

class SwitchHintDialog {
  bool isClose=true;
  final BuildContext _context;
  bool barrierDismissible;
  String actionkeyText;
  String content;
  VoidCallback executeCall;

  TextStyle? titleStyle;
  TextStyle? contentStyle;
  TextStyle? comfirmStyle;
  TextStyle? cancelStyle;

  SwitchHintDialog(this._context,
      {this.barrierDismissible=true,
        required this.actionkeyText,
        required this.content,
        required this.executeCall,
      }
  );

  ///打开loading
  void show({Function? onClosed}) async {
    isClose=false;
    SharedPreferences prefs = await SharedPreferences.getInstance();
    bool isShow=prefs.getBool(actionkeyText)??true;

    if(!isShow){

      executeCall();

    }else{
      showDialog(
        context: _context,
        barrierDismissible: barrierDismissible,
        // barrierColor: Color(0x00000001),
        builder: (context) {
          return SwitchHint(content: content,actionkeyText:actionkeyText,executeCall: executeCall);
        },
      ).then((value) {
        isClose=true;
      });
    }

  }

  ///关闭loading
  void close() {
    if(isClose){
      return;
    }
    Navigator.of(_context).pop();
  }
}



class SwitchHint extends StatefulWidget{
  String content;
  String actionkeyText;
  VoidCallback executeCall;

  TextStyle? titleStyle;
  TextStyle? contentStyle;
  TextStyle? comfirmStyle;
  TextStyle? cancelStyle;

  SwitchHint({required this.content,required this.actionkeyText,required this.executeCall});

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return _SwitchHintState();
  }

}

class _SwitchHintState extends State<SwitchHint> with TickerProviderStateMixin{
  bool noHint=false;
  double width=0;
  double height=0;
  double uiWidth=375;
  double uiHeight=812;
  @override
  void initState() {
    // TODO: implement initState
    super.initState();

  }
  
  // 375 812
  double setWidth(double value){
      return width*value/uiWidth;
  }

  double setHeight(double value){
      return height*value/uiHeight;
  }

  getSp(double value){
    double scale=dartMath.min(width/uiWidth,height/uiHeight);
    return scale*value;
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();

  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    width=MediaQuery.of(context).size.width;
    height=MediaQuery.of(context).size.height;

    return Center(
      child: Container(
        margin: new EdgeInsets.fromLTRB(setWidth(20), 0, setWidth(20),0),
        padding: new EdgeInsets.fromLTRB(0, setWidth(12), 0,setHeight(6)),
        color: Colors.white,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          mainAxisSize: MainAxisSize.min,
          children: [

            Container(
              padding: new EdgeInsets.fromLTRB(setWidth(16), setWidth(0), setWidth(12),setHeight(6)),
              child: Column(
                 crossAxisAlignment: CrossAxisAlignment.start,
                 children: [

                   Text('提示',style: widget.titleStyle??new TextStyle(
                      fontSize: 18,
                      color: Colors.black,
                      decoration: TextDecoration.none
                   ),),

                   SizedBox(
                     height: setHeight(14),
                   ),

                   Text(
                     widget.content,
                     style: widget.contentStyle??new TextStyle(
                        fontSize: 14,
                         color: Colors.black87,
                        decoration: TextDecoration.none
                   ),
                   ),

                   SizedBox(
                     height: setHeight(8),
                   ),

                 ],
              ),
            ),

            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [

                Row(
                  children: [

                    Material(
                      child: Checkbox(
                        value: noHint,
                        activeColor: Colors.blueAccent,
                        // materialTapTargetSize: MaterialTapTargetSize.padded,
                        onChanged: (value) async {

                          noHint = value!;
                          setState(() {

                          });
                          SharedPreferences prefs = await SharedPreferences.getInstance();
                          prefs.setBool(widget.actionkeyText, !noHint);

                        },
                        shape: CircleBorder(),
                      ),
                    ),

                    Text(
                      '不再提示',
                      style: widget.contentStyle??new TextStyle(
                          fontSize: 14,
                          color: Colors.black87,
                          decoration: TextDecoration.none
                      ),
                    ),

                  ],
                ),

                Row(
                  children: [

                    TextButton(
                      child: Text(
                        '取消',
                        style: widget.cancelStyle ??
                            new TextStyle(
                                fontSize: 14,
                                color: Colors.black54,
                                decoration: TextDecoration.none),
                      ),
                      onPressed: () {
                        Navigator.pop(context);
                      },
                    ),

                    TextButton(
                      child: Text(
                        '确认',
                        style: widget.comfirmStyle ??
                            new TextStyle(
                                fontSize: 14,
                                color: Colors.blueAccent,
                                fontWeight: FontWeight.bold,
                                decoration: TextDecoration.none),
                      ),
                      onPressed: () async {
                        widget.executeCall();
                        Navigator.of(context).pop();
                      },
                    ),

                  ],
                )

              ],
            )

          ],
        ),
      ),
    );
  }

}