part of flutter_kingmed_ui;

class TabBarUi extends StatefulWidget {
  List<String> tabName = [];
  Function _onClick;
  MainAxisAlignment mainAxisAlignment;
  int selectTab;
  double ? normalSize;
  double ? selectSize;
  TextStyle ? normalTextStyle;
  TextStyle ? selectTextStyle;
  Color? tabSelectColor;

  TabBarUi(this.tabName, this._onClick,{
    this.mainAxisAlignment=MainAxisAlignment.start,
    this.normalTextStyle,
    this.selectTextStyle,
    this.selectTab=0,
    this.normalSize=14,
    this.selectSize=18});

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return _TabBarUiState();
  }

}

class _TabBarUiState extends State<TabBarUi> with TickerProviderStateMixin {

  Animation<double> ?_animation;
  AnimationController ? _animationController;
  List<GlobalKey> keyList=[];
  List<double> sizeList=[];

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    widget.tabName.forEach((element) {
       keyList.add(new GlobalKey());
    });

    _animationController=new AnimationController(duration:new Duration(milliseconds: 140),vsync: this);

    _animation=new Tween<double>(begin:widget.normalSize,end:widget.selectSize).animate(_animationController!)..addListener(() {
         setState(() {

         });
    });

    _animationController!.forward();

    WidgetsBinding.instance!.addPostFrameCallback((duration){
      //RenderObject? box = keySearch.currentContext!.findRenderObject();
      //hisTop=box!.semanticBounds.height;
      keyList.forEach((element) {
        RenderObject? box = element.currentContext!.findRenderObject();
        double width=box!.semanticBounds.width+20;
        sizeList.add(width);
      });
      setState(() {

      });
    });

  }

  @override
  Widget build(BuildContext context) {

    // TODO: implement build
    return Container(
        color: Colors.white,
        height: 50,
        padding: new EdgeInsets.fromLTRB(12, 0,0,0),
        child:Row(
            children: _tabWidgets())
    );
  }

  List<Widget> _tabWidgets() {
    return widget.tabName.asMap().keys.map<Widget>((index) => new GestureDetector(
            onTap: () {
              _selectTap(index);
            },
            child: Center(
              child: Container(
                key: keyList[index],
                width: sizeList.length == 0 ? null : sizeList[index],
                //height: double.infinity,
                color: Colors.white,
                alignment: Alignment.center,
                child: Column(
                   mainAxisAlignment: MainAxisAlignment.center,
                   children: [
                     Text(
                       widget.tabName[index],
                       style: new TextStyle(
                           fontSize:widget.selectTab == index ? _animation!.value : widget.normalSize,
                           color:
                           widget.selectTab == index ? Colors.blue:Colors.black54,
                           fontWeight: widget.selectTab == index
                               ? FontWeight.bold
                               : FontWeight.normal),
                     ),
                     SizedBox(
                        height: 4,
                     ),

                     widget.selectTab == index ? Container(
                       width: sizeList.length == 0 ? null : sizeList[index]/2,
                       height: 2,
                       color: widget.tabSelectColor??Colors.blue,
                     ):SizedBox()

                   ],
                )
              ),
        ))).toList();
  }

  _selectTap(int index) {
    widget.selectTab = index;
    _animationController!.reset();
    _animationController!.forward();
    widget._onClick(index);
  }

  @override
  void dispose() {
    // TODO: implement dispose
    _animationController!.dispose();
    super.dispose();
  }

}